
class  QPushButton : public QAbstractButton
{
public:
    // explicit QPushButton(QWidget *parent=0);
    // explicit QPushButton(const QString &text, QWidget *parent=0);
    // QPushButton(const QIcon& icon, const QString &text, QWidget *parent=0);
    // ~QPushButton();

    QSize sizeHint() const;
    QSize minimumSizeHint() const;

    bool autoDefault() const;
    void setAutoDefault(bool);
    bool isDefault() const;
    void setDefault(bool);

    void setMenu(QMenu* menu);
    QMenu* menu() const;

    void setFlat(bool);
    bool isFlat() const;

public :
    void showMenu();

protected:
    bool event(QEvent *e);

    void paintEvent(QPaintEvent *);
    void keyPressEvent(QKeyEvent *);
    void focusInEvent(QFocusEvent *);
    void focusOutEvent(QFocusEvent *);
    void initStyleOption(QStyleOptionButton *option) const;
    // QPushButton(QPushButtonPrivate &dd, QWidget* parent = 0);

public:
private:
    // QPushButton(const QPushButton &); QPushButton &operator=(const QPushButton &);
    // inline QPushButtonPrivate* d_func() { return reinterpret_cast<QPushButtonPrivate *>(qGetPtrHelper(d_ptr)); } inline const QPushButtonPrivate* d_func() const { return reinterpret_cast<const QPushButtonPrivate *>(qGetPtrHelper(d_ptr)); } friend class QPushButtonPrivate;
};

int main (int argc, char * * argv)
{
     QApplication appl (argc, argv);

     QWidget * window = new QWidget ();
     window->resize (320, 240);
     window->show ();

     QPushButton * button = new QPushButton ("Press me", window);
     button->move (100, 100);
     button->show ();

     appl.exec ();
}
