
while_stat < TWhileStat: TStat > :
   "while"
   "(" cond:expr ")"
   code:stat ;

if_stat < TIfStat: TStat >  :
   "if"
   "(" cond:expr ")"
   then_code:stat
   ( "else" else_code:stat )?   ;

coumpund_stat < TCompoundStat: TSTat > :
   "{"
    ( <add> stat)*
   "}" ;

simple_stat < TSimpleStat: TStat >:
   subexpr:expr
   ";" ;

empty_stat < TEmptyStat: TStat > :
   ";" ;

stat < select TStat > :
   while_stat | if_stat | coumpund_stat | simple_stat | empty_stat ;

program < return TStat >:
   stat ;



simple_expr <TSimpleExpr> :
   name:identifier | value:number  | "(" subexpr:expr ")" ;

mult_expr <TMultExpr> :
   <add> simple_expr ( "*" <add> simple_expr )* ;

add_expr <TAddExpr> :
   <add> mult_expr ( "+" <add> mult_expr )* ;

expr <TExpr> :
   first:add_expr ( "=" second:add_expr )? ;


